# Uses of Class
org.apache.zookeeper.server.DataTree

Packages that use DataTree
Package
Description
org.apache.zookeeper.server
ZooKeeper server theory of operation
org.apache.zookeeper.server.persistence
org.apache.zookeeper.server.util

## Uses of DataTree in org.apache.zookeeper.server

Fields in org.apache.zookeeper.server declared as DataTree
Modifier and Type
Field
Description
`protected DataTree`
ZKDatabase.`dataTree`
make sure on a clear you take care of all these members.
Methods in org.apache.zookeeper.server that return DataTree
Modifier and Type
Method
Description
`DataTree`
ZKDatabase.`createDataTree()`
`DataTree`
ZKDatabase.`getDataTree()`
the datatree for this zkdatabase
Constructors in org.apache.zookeeper.server with parameters of type DataTree
Modifier
Constructor
Description
``
`DataTreeBean(DataTree dataTree)`

## Uses of DataTree in org.apache.zookeeper.server.persistence

Methods in org.apache.zookeeper.server.persistence with parameters of type DataTree
Modifier and Type
Method
Description
`long`
FileSnap.`deserialize(DataTree dt, Map<Long,Integer> sessions)`
deserialize a data tree from the most recent snapshot
`static void`
FileSnap.`deserialize(DataTree dt, Map<Long,Integer> sessions, InputArchive ia)`
deserialize the datatree from an inputarchive
`long`
SnapShot.`deserialize(DataTree dt, Map<Long,Integer> sessions)`
deserialize a data tree from the last valid snapshot and return the last zxid that was deserialized
`long`
FileTxnSnapLog.`fastForwardFromEdits(DataTree dt, Map<Long,Integer> sessions, FileTxnSnapLog.PlayBackListener listener)`
This function will fast-forward the server database to have the latest transactions in it.
`void`
FileTxnSnapLog.`processTransaction(TxnHeader hdr, DataTree dt, Map<Long,Integer> sessions, Record txn)`
process the transaction on the datatree
`long`
FileTxnSnapLog.`restore(DataTree dt, Map<Long,Integer> sessions, FileTxnSnapLog.PlayBackListener listener)`
this function restores the server database after reading from the snapshots and transaction logs
`File`
FileTxnSnapLog.`save(DataTree dataTree, ConcurrentHashMap<Long,Integer> sessionsWithTimeouts, boolean syncSnap)`
save the datatree and the sessions into a snapshot
`void`
FileSnap.`serialize(DataTree dt, Map<Long,Integer> sessions, File snapShot, boolean fsync)`
serialize the datatree and session into the file snapshot
`protected void`
FileSnap.`serialize(DataTree dt, Map<Long,Integer> sessions, OutputArchive oa, FileHeader header)`
serialize the datatree and sessions
`void`
SnapShot.`serialize(DataTree dt, Map<Long,Integer> sessions, File name, boolean fsync)`
persist the datatree and the sessions into a persistence storage

## Uses of DataTree in org.apache.zookeeper.server.util

Methods in org.apache.zookeeper.server.util with parameters of type DataTree
Modifier and Type
Method
Description
`static void`
SerializeUtils.`deserializeSnapshot(DataTree dt, InputArchive ia, Map<Long,Integer> sessions)`
`static Map<String,Number>`
QuotaMetricsUtils.`getQuotaBytesLimit(DataTree dataTree)`
Traverse the quota subtree and return per namespace quota bytes limit `
`static Map<String,Number>`
QuotaMetricsUtils.`getQuotaBytesUsage(DataTree dataTree)`
Traverse the quota subtree and return per namespace quota bytes usage
`static Map<String,Number>`
QuotaMetricsUtils.`getQuotaCountLimit(DataTree dataTree)`
Traverse the quota subtree and return per namespace quota count limit
`static Map<String,Number>`
QuotaMetricsUtils.`getQuotaCountUsage(DataTree dataTree)`
Traverse the quota subtree and return per namespace quota count usage
`static void`
SerializeUtils.`serializeSnapshot(DataTree dt, OutputArchive oa, Map<Long,Integer> sessions)`